using Contracts.Services;
using Services.Domain;
using Services.Reports;

namespace Controllers.Extensions;

public static class AddDomainServicesExtension
{
    public static void AddDomainServices(this IServiceCollection services)
    {
        services.AddTransient<IAuthService, AuthService>();
        services.AddTransient<IUserService, UserService>();
        services.AddTransient<ISpendingGroupService, SpendingGroupService>();
        services.AddTransient<IChangeRecordService, ChangeRecordService>(); 
        services.AddTransient<ISpendingPlanService, SpendingPlanService>();

        services.AddTransient<IReportPeriodService, ReportPeriodService>();
    }
}