/* eslint-disable */
/* tslint:disable */
/*
 * ---------------------------------------------------------------
 * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
 * ##                                                           ##
 * ## AUTHOR: acacode                                           ##
 * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
 * ---------------------------------------------------------------
 */

import {
  ChangeRecordDto,
  ChangeRecordViewModel,
  SpendingGroupDto,
  SpendingGroupViewModel,
  SpendingPlanDto,
  SpendingPlanViewModel,
  UserDto,
  UserLoginDto,
  UserViewModel,
} from "./data-contracts";
import { ContentType, HttpClient, RequestParams } from "./http-client";

export class Api<SecurityDataType = unknown> extends HttpClient<SecurityDataType> {
  /**
   * No description
   *
   * @tags Auth
   * @name AuthCreate
   * @request POST:/api/Auth
   * @response `200` `UserViewModel` Success
   */
  auth = (data: UserLoginDto, params: RequestParams = {}) =>
    this.request<UserViewModel, any>({
      path: `/api/Auth`,
      method: "POST",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags Auth
   * @name AuthRegisterCreate
   * @request POST:/api/Auth/register
   * @response `200` `UserViewModel` Success
   */
  authRegister = (data: UserDto, params: RequestParams = {}) =>
    this.request<UserViewModel, any>({
      path: `/api/Auth/register`,
      method: "POST",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags ChangeRecord
   * @name ChangeRecordCreate
   * @request POST:/api/ChangeRecord
   * @response `200` `ChangeRecordViewModel` Success
   */
  changeRecordCreate = (data: ChangeRecordDto, params: RequestParams = {}) =>
    this.request<ChangeRecordViewModel, any>({
      path: `/api/ChangeRecord`,
      method: "POST",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags ChangeRecord
   * @name ChangeRecordList
   * @request GET:/api/ChangeRecord
   * @response `200` `(ChangeRecordViewModel)[]` Success
   */
  changeRecordList = (params: RequestParams = {}) =>
    this.request<ChangeRecordViewModel[], any>({
      path: `/api/ChangeRecord`,
      method: "GET",
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags ChangeRecord
   * @name ChangeRecordPartialUpdate
   * @request PATCH:/api/ChangeRecord
   * @response `200` `ChangeRecordViewModel` Success
   */
  changeRecordPartialUpdate = (data: ChangeRecordDto, params: RequestParams = {}) =>
    this.request<ChangeRecordViewModel, any>({
      path: `/api/ChangeRecord`,
      method: "PATCH",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags ChangeRecord
   * @name ChangeRecordDelete
   * @request DELETE:/api/ChangeRecord
   * @response `200` `void` Success
   */
  changeRecordDelete = (
    query?: {
      /** @format uuid */
      Id?: string;
      /** @format uuid */
      SpendingGroupId?: string;
      /** @format date-time */
      From?: string;
      /** @format date-time */
      To?: string;
      /** @format uuid */
      UserId?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<void, any>({
      path: `/api/ChangeRecord`,
      method: "DELETE",
      query: query,
      ...params,
    });
  /**
   * No description
   *
   * @tags ChangeRecord
   * @name ChangeRecordFilterList
   * @request GET:/api/ChangeRecord/filter
   * @response `200` `(ChangeRecordViewModel)[]` Success
   */
  changeRecordFilterList = (
    query?: {
      /** @format uuid */
      Id?: string;
      /** @format uuid */
      SpendingGroupId?: string;
      /** @format date-time */
      From?: string;
      /** @format date-time */
      To?: string;
      /** @format uuid */
      UserId?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<ChangeRecordViewModel[], any>({
      path: `/api/ChangeRecord/filter`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags Report
   * @name ReportPeriodList
   * @request GET:/api/Report/period/{id}
   * @response `200` `(ChangeRecordViewModel)[]` Success
   */
  reportPeriodList = (
    id: string,
    query?: {
      /** @format date-time */
      from?: string;
      /** @format date-time */
      to?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<ChangeRecordViewModel[], any>({
      path: `/api/Report/period/${id}`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags Report
   * @name ReportPlanDetail
   * @request GET:/api/Report/plan/{id}
   * @response `200` `SpendingGroupViewModel` Success
   */
  reportPlanDetail = (id: string, params: RequestParams = {}) =>
    this.request<SpendingGroupViewModel, any>({
      path: `/api/Report/plan/${id}`,
      method: "GET",
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingGroup
   * @name SpendingGroupDetail
   * @request GET:/api/SpendingGroup/{id}
   * @response `200` `SpendingGroupViewModel` Success
   */
  spendingGroupDetail = (
    id: string,
    query?: {
      /** @format uuid */
      Id?: string;
      Name?: string;
      /** @format uuid */
      UserId?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<SpendingGroupViewModel, any>({
      path: `/api/SpendingGroup/${id}`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingGroup
   * @name SpendingGroupList
   * @request GET:/api/SpendingGroup
   * @response `200` `(SpendingGroupViewModel)[]` Success
   */
  spendingGroupList = (params: RequestParams = {}) =>
    this.request<SpendingGroupViewModel[], any>({
      path: `/api/SpendingGroup`,
      method: "GET",
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingGroup
   * @name SpendingGroupCreate
   * @request POST:/api/SpendingGroup
   * @response `200` `SpendingGroupViewModel` Success
   */
  spendingGroupCreate = (data: SpendingGroupDto, params: RequestParams = {}) =>
    this.request<SpendingGroupViewModel, any>({
      path: `/api/SpendingGroup`,
      method: "POST",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingGroup
   * @name SpendingGroupPartialUpdate
   * @request PATCH:/api/SpendingGroup
   * @response `200` `SpendingGroupViewModel` Success
   */
  spendingGroupPartialUpdate = (data: SpendingGroupDto, params: RequestParams = {}) =>
    this.request<SpendingGroupViewModel, any>({
      path: `/api/SpendingGroup`,
      method: "PATCH",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingGroup
   * @name SpendingGroupDelete
   * @request DELETE:/api/SpendingGroup
   * @response `200` `void` Success
   */
  spendingGroupDelete = (
    query?: {
      /** @format uuid */
      Id?: string;
      Name?: string;
      /** @format uuid */
      UserId?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<void, any>({
      path: `/api/SpendingGroup`,
      method: "DELETE",
      query: query,
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingGroup
   * @name SpendingGroupFilterList
   * @request GET:/api/SpendingGroup/filter
   * @response `200` `(SpendingGroupViewModel)[]` Success
   */
  spendingGroupFilterList = (
    query?: {
      /** @format uuid */
      Id?: string;
      Name?: string;
      /** @format uuid */
      UserId?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<SpendingGroupViewModel[], any>({
      path: `/api/SpendingGroup/filter`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingPlan
   * @name SpendingPlanDetail
   * @request GET:/api/SpendingPlan/{id}
   * @response `200` `SpendingPlanViewModel` Success
   */
  spendingPlanDetail = (
    id: string,
    query?: {
      /** @format uuid */
      Id?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<SpendingPlanViewModel, any>({
      path: `/api/SpendingPlan/${id}`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingPlan
   * @name SpendingPlanList
   * @request GET:/api/SpendingPlan
   * @response `200` `(SpendingPlanViewModel)[]` Success
   */
  spendingPlanList = (params: RequestParams = {}) =>
    this.request<SpendingPlanViewModel[], any>({
      path: `/api/SpendingPlan`,
      method: "GET",
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingPlan
   * @name SpendingPlanCreate
   * @request POST:/api/SpendingPlan
   * @response `200` `SpendingPlanViewModel` Success
   */
  spendingPlanCreate = (data: SpendingPlanDto, params: RequestParams = {}) =>
    this.request<SpendingPlanViewModel, any>({
      path: `/api/SpendingPlan`,
      method: "POST",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingPlan
   * @name SpendingPlanPartialUpdate
   * @request PATCH:/api/SpendingPlan
   * @response `200` `SpendingPlanViewModel` Success
   */
  spendingPlanPartialUpdate = (data: SpendingPlanDto, params: RequestParams = {}) =>
    this.request<SpendingPlanViewModel, any>({
      path: `/api/SpendingPlan`,
      method: "PATCH",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingPlan
   * @name SpendingPlanDelete
   * @request DELETE:/api/SpendingPlan
   * @response `200` `void` Success
   */
  spendingPlanDelete = (
    query?: {
      /** @format uuid */
      Id?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<void, any>({
      path: `/api/SpendingPlan`,
      method: "DELETE",
      query: query,
      ...params,
    });
  /**
   * No description
   *
   * @tags SpendingPlan
   * @name SpendingPlanFilterList
   * @request GET:/api/SpendingPlan/filter
   * @response `200` `(SpendingPlanViewModel)[]` Success
   */
  spendingPlanFilterList = (
    query?: {
      /** @format uuid */
      Id?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<SpendingPlanViewModel[], any>({
      path: `/api/SpendingPlan/filter`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags User
   * @name UserList
   * @request GET:/api/User
   * @response `200` `UserViewModel` Success
   */
  userGet = (
    query?: {
      /** @format uuid */
      Id?: string;
      Name?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<UserViewModel, any>({
      path: `/api/User`,
      method: "GET",
      query: query,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags User
   * @name UserPartialUpdate
   * @request PATCH:/api/User
   * @response `200` `UserViewModel` Success
   */
  userPartialUpdate = (data: UserDto, params: RequestParams = {}) =>
    this.request<UserViewModel, any>({
      path: `/api/User`,
      method: "PATCH",
      body: data,
      type: ContentType.Json,
      format: "json",
      ...params,
    });
  /**
   * No description
   *
   * @tags User
   * @name UserDelete
   * @request DELETE:/api/User
   * @response `200` `UserViewModel` Success
   */
  userDelete = (
    query?: {
      /** @format uuid */
      Id?: string;
      Name?: string;
    },
    params: RequestParams = {},
  ) =>
    this.request<UserViewModel, any>({
      path: `/api/User`,
      method: "DELETE",
      query: query,
      format: "json",
      ...params,
    });
}
