import { useUserStore } from "../../store";
import { Api } from "../api/Api";
import { SpendingGroupDto, SpendingGroupViewModel } from "../api/data-contracts";

export class GroupService {
    private readonly _api: Api;
    constructor(api: Api) {
        this._api = api;
    }

    async getList(): Promise<SpendingGroupViewModel[] | null> {
        const store = useUserStore();
        console.log("get list " + store.user.id);
        if (!store.user.id) return null;

        let UserId = store.user.id;
        let result = await this._api.spendingGroupFilterList({ UserId });

        console.log(result);
        return result.data;
    }

    async deleteGroup(Id: string) {
        let result = await this._api.spendingGroupDelete({ Id });
        console.log("delete");
        console.log(result);
    }

    async createGroup(data: SpendingGroupDto) {
        let result = await this._api.spendingGroupCreate(data);
        console.log(result);
    }
}